<template>
  <b-table
    :data="activites"
    sort-icon="chevron-up"
    default-sort-direction="asc"
    default-sort="dateDebut"
    :checked-rows.sync="activitesSelectionnees"
    :row-class="resolveClass"
    hoverable
    @click="selected"
  >
    <template #default="{ row: activite }">
      <b-table-column class="mt-align-middle no-wrap" field="dateDebut" label="Dates" sortable>
        <mt-date-range-short
          class="is-uppercase has-text-weight-bold"
          :start="activite.dateDebut"
          :end="activite.dateFin"
        />
      </b-table-column>
      <b-table-column class="mt-align-middle" field="nom" label="Nom de l'activité" sortable>
        {{ activite.nom }}
      </b-table-column>
      <b-table-column class="mt-align-middle no-wrap" field="avancement.taux.pourcentage" label="Avancement" sortable>
        <mt-progress-activity :activite="activite" />
        <div class="has-text-grey is-size-7">
          {{ activite.avancement.taux.nombre }} / {{ activite.avancement.taux.total }}
        </div>
      </b-table-column>
      <b-table-column v-if="isEmploye" class="mt-align-middle no-wrap" field="estDispo" label="Dispo" sortable centered>
        <span v-if="activite.estDispo" class="mt-disponibilite-status-puce mt-puce-disponible" />
        <span v-else class="mt-disponibilite-status-puce mt-puce-indisponible" />
      </b-table-column>
      <b-table-column
        v-if="isEmploye"
        class="mt-align-middle no-wrap"
        field="monStatut"
        label="Statut"
        sortable
        centered
      >
        <span v-if="estParticipant(activite)" class="mt-statut">{{ activite.monStatut }}</span>
      </b-table-column>
    </template>
    <template slot="empty">
      <section class="section">
        <div class="content has-text-grey has-text-centered">
          <p>
            <b-icon icon="emoticon-sad" size="is-large"> </b-icon>
          </p>
          <p>Aucune activité</p>
        </div>
      </section>
    </template>
  </b-table>
</template>

<script>
import { classResolver } from '~/components/mixins/activityMixin';
import MtDateRangeShort from './date-range-short';
import MtProgressActivity from '~/components/activity/progress-users-activity';

export default {
  components: {
    MtDateRangeShort,
    MtProgressActivity,
  },
  mixins: [classResolver],
  props: {
    activites: {
      type: Array,
      default: () => [],
    },
  },
  data() {
    return {
      activitesSelectionnees: [],
      isEmploye: this.$store.getters['context/isEmploye'],
    };
  },
  methods: {
    resolveClass(row) {
      return this.resolveTypeActivite(row, 'mt-list-item-').class;
    },
    deleteActivitesSelectionnees() {
      this.$emit('delete-activites-selectionnees', this.activitesSelectionnees);
      this.activitesSelectionnees = [];
    },
    estParticipant(activite) {
      return activite.participants.length !== 0;
    },
    selected(activite) {
      this.$router.push(this.profilLink({ name: 'activites-id', params: { id: activite.id } }));
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
a {
  display: flex;
  align-items: baseline;
}
/deep/ {
  table.table {
    border-collapse: collapse;
  }
  .table tbody tr td {
    border-width: 1px 0 0;
    cursor: pointer;
  }
  .table tbody tr:last-child td {
    border-bottom-width: 1px;
  }
  .table thead {
    th {
      border-width: 0;
      .checkbox {
        height: 24px;
      }
    }
  }
  .progress {
    height: 0.5rem;
  }
  .mt-align-middle {
    vertical-align: middle;
  }
  .progress {
    width: 50px;
    margin-right: 15px;
  }
  .progress-wrapper:not(:last-child) {
    margin-bottom: 0;
  }
  .icon {
    vertical-align: middle;
  }
  .table.is-hoverable tbody tr:not(.is-selected):hover {
    background-color: $pale-grey-three;
  }
  .mt-disponibilite-status-puce {
    display: inline-block;
    width: 9px;
    height: 9px;
    border-radius: 50%;
    margin: auto 5px auto 0;
  }
}
</style>
